lli  R30 FFFFh   // setup stack pointer
lui  R30 0003h

jal  XBLANK

xor  R1  R1  R1
lli  R1  003Ah
add  R29 R1  R0  // on reset, will be available

// start setting up initial message
lli  R3  5000h
lui  R3  0001h
xor  R1  R1  R1
//  54 45 53 54 20 50 52 4F 47 52 41 4D 3A
//  T  E  S  T     P  R  O  G  R  A  M  :
lli  R1  0054h
jal  XPUTC
lli  R1  0045h
jal  XPUTC
lli  R1  0053h
jal  XPUTC
lli  R1  0054h
jal  XPUTC
lli  R1  0020h
jal  XPUTC
lli  R1  0050h
jal  XPUTC
lli  R1  0052h
jal  XPUTC
lli  R1  004Fh
jal  XPUTC
lli  R1  0047h
jal  XPUTC
lli  R1  0052h
jal  XPUTC
lli  R1  0041h
jal  XPUTC
lli  R1  004Dh
jal  XPUTC
lli  R1  003Ah
jal  XPUTC

jal  XRDLN            // get and echo a line

// START OF FUNCTIONAL TEST
lli  R15 5678h
lui  R15 1234h        // R15 = 12345678h
lli  R14 5A90h
lui  R14 014Bh
not  R13 R14          // R13 = FEB4A56Fh
or   R12 R15 R14      // R12 = 137F5EF8h
and  R11 R13 R15      // R11 = 00200567h
push R11
pop  R10              // R10 = 00200567h
add  R9  R12 R13      // R9  = 12340467h
xor  R8  R8  R8
inc  R8
sub  R8  R9  R8       // R8  = 12340466h
xor  R7  R7  R7
dec  R7               // R7  = FFFFFFFFh

// BEGIN FINAL SIGNATURE DETERMINATION
add  R5  R15 R14
add  R4  R13 R12
add  R3  R11 R10
add  R2  R9  R8
add  R5  R5  R4
add  R5  R5  R3
add  R5  R5  R2
add  R5  R5  R7
lli  R4  C70Bh
lui  R4  6E83h

xor  R1  R1  R1

breq R4  R5  WORKS

// IF THIS GETS EXECUTED, IT DIDN'T WORK
// F  A  I  L
// 46 41 49 4C
lli  R1  0046h
jal  XPUTC
lli  R1  0041h
jal  XPUTC
lli  R1  0049h
jal  XPUTC
lli  R1  004Ch
jal  XPUTC
br   P2COMP

:WORKS
// P  A  S  S
// 50 41 53 53
lli  R1  0050h
jal  XPUTC
lli  R1  0041h
jal  XPUTC
lli  R1  0053h
jal  XPUTC
jal  XPUTC
:P2COMP

jal  XQUIT

// XBLANK blanks the screen
:XBLANK
push R31

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31
jr   R31

// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31


// XRDLN reads a line from the user
// and places it in memory starting at
// addr specified by R3.  Echoes the
// line as it is typed to the user.

:XRDLN
push R31
push R1          // context save
push R2
push R3
push R4
push R5
add  R4  R31 R0  // save return addr
xor  R2  R2  R2
lli  R2  000Ah   // LF char
xor  R5  R5  R5
lli  R5  0008h   // backspace

:XRDLN1
breq R1  R2  XRDLN2   // if enter pressed
jal  XGETC            // else getc
breq R1  R5  XRDLN3   // if backspace char
sw   R1  R3  0        // store in mem
inc  R3               // inc addr
jal  XPUTC            // echo the char
br   XRDLN1           // keep getting chars
:XRDLN3
dec  R3               // dec address if backsp
jal  XPUTC
br XRDLN1
:XRDLN2
sw   R0  R3  -1       // null terminate      


add  R31 R4  R0       // restore return addr

pop  R5               // context restore
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31


// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

:XQUIT
jal  XPUTC      // flood the screen
br   XQUIT
stop
