lli  R2  000Dh
lli  R30 FFFFh
lli  R3  0010h
lli  R1  ABCDh
jal  XRDLN
jal  XPRINT
jal  XPUTPX
jal  XQUIT

// XPRINT reads a line from memory and
// prints it on the screen.  Starts
// looking at address specified by R3.
// Expects a null-terminated string.

:XPRINT
push R1
push R3
push R4
add  R4  R31 R0  // save return addr
:XPRINT1
lw   R1  R3  0
breq R1  R0  XPRINT2
jal  XPUTC
inc  R3
br   XPRINT1
:XPRINT2
add  R31 R4  R0
pop  R4
pop  R3
pop  R1
jr   R31

// XRDLN reads a line from the user
// and places it in memory starting at
// addr specified by R3.  Echoes the
// line as it is typed to the user.

:XRDLN
push R1          // context save
push R2
push R3
push R4
push R5
add  R4  R31 R0  // save return addr
xor  R2  R2  R2
lli  R2  000Dh   // LF char
xor  R5  R5  R5
lli  R5  0008h   // backspace

:XRDLN1
breq R1  R2  XRDLN2   // if enter pressed
jal  XGETC            // else getc
breq R1  R5  XRDLN3   // if backspace char
sw   R1  R3  0        // store in mem
inc  R3               // inc addr
jal  XPUTC            // echo the char
br   XRDLN1           // keep getting chars
:XRDLN3
dec  R3               // dec address if backsp
jal  XPUTC
br XRDLN1
:XRDLN2
sw   R0  R3  -1       // null terminate      

lli  R1  000Ah        // CR char
jal  XPUTC
add  R1  R2  R0       // LF char
jal  XPUTC

add  R31 R4  R0       // restore return addr

pop  R5               // context restore
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31


// XRDLNX reads a line from the user
// and places it in memory starting at
// addr specified by R3.  DOES NOT
// ECHO THAT LINE TO THE USER.

:XRDLNX
push R1
push R2
push R3
push R4
push R5
add  R4  R31 R0  // save return addr
xor  R2  R2  R2
lli  R2  000Dh
xor  R5  R5  R5
lli  R5  0008h

:XRDLNX1
breq R1  R2  XRDLNX2
jal  XGETC
breq R1  R5  XRDLNX3  // backspace char
sw   R1  R3  0
inc  R3
br   XRDLNX1
:XRDLNX3
dec  R3
br XRDLNX1
:XRDLNX2
sw   R0  R3  -1      
add  R31 R4  R0
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31


// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

:XQUIT
stop
