lli  R30 FFFFh
lui  R30 0003h
jal  XBLANK
jal  XQUIT

lli  R1,  100Ah
lui  R1  10FFh
lli  R2  2410h
lli  R3  3410h
lli  R10 0000h
lli  R11 0000h
lli  R12 00FFh
lli  R13 00FFh
lli  R14 00E7h
lli  R15 0079h
add  R29  R2  R1
:XLABA
jal  XGETC
jal  XPUTC
br   XLABA
jal  XQUIT

// XBLANK blanks the screen
:XBLANK
push R31

xor  R1  R1  R1
xor  R2  R2  R2
xor  R3  R3  R3
xor  R4  R4  R4
xor  R5  R5  R5
lli  R4  368      // X-Width
lli  R5  480      // Y-Width

:XBLANK0
jal  XVGA
inc  R2
brgt R2  R4  XBLANK1
br   XBLANK0

:XBLANK1
xor  R2  R2  R2
inc  R3
brgt R3  R5  XBLANK2
br   XBLANK0

:XBLANK2

pop  R31
jr   R31

// XLNVT prints a vertical line
// Arguments - R10 - X-position
//             R11 - length of line
//             R12 - Y-position of topmost point
//             R13 - line colour
:XLNVT
push R31
push R1
push R2
push R3
push R11
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R12
:XLNVT0
jal  XVGA
inc  R3
brgt R3  R11 XLNVT1
br  XLNVT0
:XLNVT1
pop  R11
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

// XLNHZ prints a horizontal line
// Arguments - R10 - X-position of leftmost point
//             R11 - length of line
//             R12 - Y-position of line
//             R13 - line colour
:XLNHZ
push R31
push R1
push R2
push R3
push R11
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R10
:XLNHZ0
jal XVGA
inc  R2
brgt R2  R11 XLNHZ1
br  XLNHZ0
:XLNHZ1
pop  R11
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

// XSQRF prints a filled sqaure on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
//             R15 - fill colour
:XSQRF
push R31
push R10
push R11
push R12
push R13
push R14
jal XSQR    // print outline
add  R14  R15  R0  // switch outline colour to fill
:XSQRF0
inc  R10
inc  R11
dec  R12
dec  R13    // close box in 1 pixel
brgt R10 R12 XSQRF1
brgt R11 R13 XSQRF1
jal XSQR
br XSQRF0
:XSQRF1
pop  R14
pop  R13
pop  R12
pop  R11
pop  R10
pop  R31
jr   R31

// XSQR prints a square on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
:XSQR
push R31
push R1
push R2
push R3
add  R1  R14  R0
add  R2  R10  R0
add  R3  R11  R0
breq R10 R12  XSQRX
breq R11 R13  XSQRY
:XSQRA
jal XVGA
inc R2
brgt R2 R12 XSQR1
br XSQRA
:XSQR1
dec R2
:XSQRB
inc R3
brgt R3 R13 XSQR2
jal XVGA
br XSQRB
:XSQR2
dec R3
:XSQRC
dec R2
brlt R2 R10 XSQR3
jal XVGA
br XSQRC
:XSQR3
inc R2
:XSQRD
dec R3
breq R3 R11 XSQR4
jal XVGA
br XSQRD
:XSQRX
push R11
push R12
push R13
add R12 R11 R0
sub R11 R13 R11
add R13 R14 R0
jal XLNVT
pop  R13
pop  R12
pop  R11
br XSQR4
:XSQRY
push R11
push R12
push R13
sub R11 R12 R10
add R12 R13 R0
add R13 R14 R0
jal  XLNHZ
pop  R13
pop  R12
pop  R11
:XSQR4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31

// XRFDMP dumps the register file to the screen
// Notes: Register 29 is not dumped.
// Memory locations 8000h - 8009h are corrupted
// by this procedure.
:XRFDMP
push R31
push R1
push R2
push R3
push R4
push R5
push R6
push R7
push R8
push R15
push R16     // context save

push R31
push R30
push R28
push R27
push R26
push R25
push R24
push R23
push R22
push R21
push R20
push R19
push R18
push R17
push R16
push R15
push R14
push R13
push R12
push R11
push R10
push R9
push R8
push R7
push R6
push R5
push R4
push R3
push R2
push R1
push R0

xor  R2  R2  R2
xor  R4  R4  R4
xor  R5  R5  R5
xor  R6  R6  R6
xor  R7  R7  R7
xor  R8  R8  R8
xor  R15 R15 R15
lli  R2  0052h   // 'R'
lli  R6  0020h   // ' '
lli  R4  003Dh   // '='
lli  R7  001Dh   // 29
lli  R8  001Fh   // 31
lli  R15 8000h

// start printing loop
:XRFDMPA
add  R1  R2  R0
jal  XPUTC       // put 'R'

add  R16 R5  R0
jal  XRG2C       // convert reg num to printable
add  R3  R15 R0
jal  XPRINT       // print register number
add  R1  R6  R0
jal  XPUTC       // print space
add  R1  R4  R0
jal  XPUTC       // print '='
add  R1  R6  R0
jal  XPUTC       // print space

pop  R16         // pop next reg to print
jal  XRG2C       // convert to printable
add  R3  R15 R0
jal  XPRINT       // print register contents
jal  XNWLN       // print new line
inc  R5          // increment current register

breq R5 R7 XRFDMP0
br   XRFDMP1
:XRFDMP0
inc  R5
:XRFDMP1
brgt R5 R8 XRFDMP2
br   XRFDMPA     // start over

:XRFDMP2

pop  R16         // context restore
pop  R15
pop  R8
pop  R7
pop  R6
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
jr   R31



// XRG2C converts a register to
// a printable form (in hex)
// Arguments:
// R15 - Starting address for output
// R16 - Value that will be printed
:XRG2C
push R1
push R2
push R3
push R4
push R5
push R10
push R11
push R13
push R15
xor  R1   R1   R1
xor  R2   R2   R2
xor  R4   R4   R4
xor  R3   R3   R3
xor  R5   R5   R5
xor  R10  R10  R10
lli  R13  FFFCh
lui  R13  FFFFh
lli  R4   0004h
lli  R10  001Ch
lli  R3   0009h
lli  R1   000Fh
sw   R0   R15  9    // null terminate

:XRG2C1
srl  R11   R16  R10 // bring next nibble to LSN
and  R11   R11  R1  // isolate nibble
sub  R10   R10  R4  // subtract 4 from shift amount

// R11 is now between 0000_0000 and 0000_000F
brgt R11   R3   XRG2CA  // if char is A or greater

// char must be between 0 and 9
lli  R2   0030h
add  R11  R11   R2   // now converted to character
br   XRG2C0

:XRG2CA
lli  R2   0037h
add  R11  R11   R2   // now converted to character

:XRG2C0
sw   R11  R15   0    // store off the character
inc  R15             // go to next addr
brgt R10  R13   XRG2C1

// must be done
pop  R15
pop  R13
pop  R11
pop  R10
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31 // return

// XNWLN prints a newline character
:XNWLN
push R31
push R1
xor  R1  R1  R1
lli  R1  000Ah        // CR char
jal  XPUTC
lli  R1  000Dh       // LF char
jal  XPUTC
pop  R1
pop  R31
jr   R31

// XPRINT reads a line from memory and
// prints it on the screen.  Starts
// looking at address specified by R3.
// Expects a null-terminated string.

:XPRINT
push R1
push R3
push R4
add  R4  R31 R0  // save return addr
:XPRINT1
lw   R1  R3  0
breq R1  R0  XPRINT2
jal  XPUTC
inc  R3
br   XPRINT1
:XPRINT2
add  R31 R4  R0
pop  R4
pop  R3
pop  R1
jr   R31

// XRDLN reads a line from the user
// and places it in memory starting at
// addr specified by R3.  Echoes the
// line as it is typed to the user.

:XRDLN
push R1          // context save
push R2
push R3
push R4
push R5
add  R4  R31 R0  // save return addr
xor  R2  R2  R2
lli  R2  000Dh   // LF char
xor  R5  R5  R5
lli  R5  0008h   // backspace

:XRDLN1
breq R1  R2  XRDLN2   // if enter pressed
jal  XGETC            // else getc
breq R1  R5  XRDLN3   // if backspace char
sw   R1  R3  0        // store in mem
inc  R3               // inc addr
jal  XPUTC            // echo the char
br   XRDLN1           // keep getting chars
:XRDLN3
dec  R3               // dec address if backsp
jal  XPUTC
br XRDLN1
:XRDLN2
sw   R0  R3  -1       // null terminate      

lli  R1  000Ah        // CR char
jal  XPUTC
add  R1  R2  R0       // LF char
jal  XPUTC

add  R31 R4  R0       // restore return addr

pop  R5               // context restore
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31


// XRDLNX reads a line from the user
// and places it in memory starting at
// addr specified by R3.  DOES NOT
// ECHO THAT LINE TO THE USER.

:XRDLNX
push R1
push R2
push R3
push R4
push R5
add  R4  R31 R0  // save return addr
xor  R2  R2  R2
lli  R2  000Dh
xor  R5  R5  R5
lli  R5  0008h

:XRDLNX1
breq R1  R2  XRDLNX2
jal  XGETC
breq R1  R5  XRDLNX3  // backspace char
sw   R1  R3  0
inc  R3
br   XRDLNX1
:XRDLNX3
dec  R3
br XRDLNX1
:XRDLNX2
sw   R0  R3  -1      
add  R31 R4  R0
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
jr   R31


// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

:XQUIT
stop
