nop
nop
nop
nop
nop
nop

lli  R30 FFFFh
lui  R30 0003h   // setup stack pointer

// Setup initial terminal count variable
lui  R1  0001h
lli  R1  6100h
lli  R2  0000h
lui  R2  0001h  // term count == 10000h
sw   R2  R1  1

// Setup initial "current" block info
lli  R1  5100h
sw   R0  R1  2  // start piece type at 0


//jal  TSETUP
lli  R1  5000h
lui  R2  8000h
lli  R2  0010h
xor  R3  R3  R3
lli  R3  00C9h
:TINIT0
sw   R2  R1  0
inc  R1
inc  R2
dec  R3
brgt R3 R0 TINIT0

jal  TDRBRDI
jal  TDRBRD
jal  XQUIT

// TLOSE is the lose function
:TLOSE
jr   R0

// TCHECK checks for a loss
// Returns:      If it returns, there's no loss
// YET TO IMPLEMENT
:TCHECK
push R31
push R1
pop  R1
pop  R31
nop
nop
nop
jr   R31

// TSPAWN spawns a new piece
:TSPAWN
push R31
lli  R1  5100h
lui  R1  0001h   // load current piece address
xor  R2  R2  R2
lli  R2  000Ah
sw   R2  R1  0   // spawn block at middle of board
lw   R2  R1  2   // get last piece type
inc  R2
xor  R3  R3  R3
lli  R3  0007h
and  R2  R2  R3  // keep current piece in bounds
sw   R2  R1  2   // write out this piece's type
sw   R0  R1  3   // set floating status to FLOATING
lui  R4  FFFFh
lli  R4  FFFCh   // initial y-pos
sw   R0  R1  4   // set initial rotation state 0
nop
sw   R4  R1  1   // write initial y-pos

// PUT PIECE ON BOARD INITIALLY 
jal  TDOWN

// CHECK LOSS CONDITON
jal  TCHECK

// it TCHECK returns, we haven't lost yet

pop  R31
nop
nop
nop
jr   R31

// TDOWN does a down
:TDOWN
push R31
lli  R1  5000h
lui  R1  0001h   // R1 is board base address
lli  R2  5100h
lui  R2  0001h   // R2 is current block base addr
lli  R3  6000h
lui  R3  0001h   // R3 is block type LUT base addr
lw   R5  R2  2   // R5 is current piece type
xor  R4  R4  R4
lli  R4  0004h   // R4 is "4"
sl   R5  R5  R4  // R3+R5 is current block type addr
add  R3  R3  R5  // R3 is current block type addr
lw   R10 R2  0   // R10 is current block x-loc
lw   R11 R2  1   // R11 is current block y-loc
lw   R12 R2  4   // R12 is current piece rotation
lli  R13 0000h
lui  R13 4000h   // R13 is mask for ROT0 bit
srl  R13 R13 R12 // R13 is mask for current ROT bit

// CONTINUE WORK HERE

pop  R31
nop
nop
nop
jr   R31

// TMOVE does a move
:TMOVE
push R31
lli  R1 004Dh
jal  XPUTC
pop  R31
nop
nop
nop
jr   R31

// TROT does a rotation
:TROT
push R31
lli  R1 0072h
jal  XPUTC
pop  R31
nop
nop
nop
jr   R31

// TPAUSE pauses the game
:TPAUSE
push R31
// P  A  U  S  E  D
// 50 41 55 53 45 44
lli  R1 0050h
jal  XPUTC
lli  R1 0041h
jal  XPUTC
lli  R1 0055h
jal  XPUTC
lli  R1 0053h
jal  XPUTC
lli  R1 0045h
jal  XPUTC
lli  R1 0044h
jal  XPUTC
// printed
lli  R7 0070h
:TPAUSE0
jal  XGETC
breq R1  R7  TPAUSE1
br TPAUSE0
:TPAUSE1
lli  R1 0008h
jal  XPUTC
jal  XPUTC
jal  XPUTC
jal  XPUTC
jal  XPUTC
jal  XPUTC
jal  XPUTC
jal  XPUTC
// backspaces printed
jal  TDRBRDI  // re-draw board
jal  TDRBRD

pop  R31
nop
nop
nop
jr   R31

// TUSRIN performs the user-input polling loop
// U/D/L/R moves
// SPACE rotates
// r restarts
// p pauses
:TUSRIN
push R31
xor  R3  R3  R3   // used for input checking
lli  R1  6100h
lui  R1  0001h    // load user count address
sw   R0  R1  0
lw   R2  R1  1    // load terminal count value

xor  R1  R1  R1   // XOR is now count

:TUIN
brchar TUIN0       // if key pressed, process it
inc  R1
brgt R1  R2  TUINX // if count exceeds terminal, leave userin
br TUIN            // otherwise keep spinning

// time to process input
:TUIN0
add  R1  R29  R0   // get from R29
lli  R3  0032h
breq R1  R3 TUINM  // do a move
lli  R3  0034h
breq R1  R3 TUINM  // do a move
lli  R3  0036h
breq R1  R3 TUINM  // do a move
lli  R3  0038h
breq R1  R3 TUINM  // do a move

lli  R3  0020h
breq R1  R3 TUINR  // do a rotate

lli  R3  0070h
breq R1  R3 TUINP  // do a pause

lli  R3  0072h
breq R1  R3 TUINB  // do a restart

br   TUIN          // input was garbage

// do a move
:TUINM
jal TMOVE
br  TUIN

// do a rotate
:TUINR
jal TROT
br  TUIN

// do a pause
:TUINP
jal TPAUSE
br  TUIN

// do a restart, bye-bye!
:TUINB
lli R1  0058h
jal XPUTC
jr  R0

:TUINX
dec  R2         // decrment terminal count value (faster)
lli  R1  6100h
lui  R1  0001h
sw   R2  R1  1  // store-back terminal count value
nop
pop  R31
nop
nop
nop
jr   R31

// TSETUP loads memory with the block types and
// a blank board (may be replaced by a .data section)
:TSETUP
push R31
xor  R3  R3  R3
lui  R1  0001h

lli  R1  5000h
lli  R3  00C9h
:TSETUP1
// clear board initially
sw   R1  R1  0
inc  R1
dec  R3
brgt R3  R0 TSETUP1

lli  R1  6000h
lli  R3  0080h
:TSETUP0
// clear all relevent memory locs
sw   R0  R1  0
inc  R1
dec  R3
brgt R3  R0 TSETUP0
lli  R1  6000h   // start setting up block tables
lli  R2  00E0h   // block type 0
lui  R2  0800h
lli  R3  0010h
sw   R2  R1  5
lui  R2  5000h
sw   R2  R1  6
sw   R2  R1  14
lui  R2  4000h
sw   R2  R1  7
lui  R2  4800h
sw   R2  R1  9
sw   R2  R1  11
lui  R2  7800h
sw   R2  R1  10
lui  R2  1000h
sw   R2  R1  13
lui  R2  2000h
sw   R2  R1  15
add  R1  R1  R3  // go to next block type
lli  R2  0018h   // block type 1
lui  R2  4000h
sw   R2  R1  5
lui  R2  5000h
sw   R2  R1  6
sw   R2  R1  14
lui  R2  2000h
sw   R2  R1  7
lui  R2  4800h
sw   R2  R1  9
sw   R2  R1  11
lui  R2  7800h
sw   R2  R1  10
lui  R2  0800h
sw   R2  R1  13
lui  R2  1000h
sw   R2  R1  15
add  R1  R1  R3  // go to next block type
lli  R2  0007h   // block type 2
lui  R2  2800h
sw   R2  R1  3
sw   R2  R1  7
sw   R2  R1  11
lui  R2  5000h
sw   R2  R1  12
sw   R2  R1  13
sw   R2  R1  14
lui  R2  7800h
sw   R2  R1  15
add  R1  R1  R3  // go to next block type
lli  R2  00F8h   // block type 3
sw   R2  R1  10
lui  R2  5000h
sw   R2  R1  5
sw   R2  R1  6
sw   R2  R1  14
sw   R2  R1  15
lui  R2  2800h
sw   R2  R1  7
sw   R2  R1  9
sw   R2  R1  11
sw   R2  R1  13
add  R1  R1  R3  // go to next block type
lli  R2  001Fh   // block type 4
sw   R2  R1  5
sw   R2  R1  9
sw   R2  R1  11
sw   R2  R1  15
lui  R2  5000h
sw   R2  R1  6
sw   R2  R1  7
sw   R2  R1  13
sw   R2  R1  14
lui  R2  7800h
sw   R2  R1  10
add  R1  R1  R3  // go to next block type
lli  R2  00F0h   // block type 5
sw   R2  R1  10
sw   R2  R1  11
sw   R2  R1  14
sw   R2  R1  15
add  R1  R1  R3  // go to next block type
lli  R2  0068h   // block type 6
sw   R2  R1  10
lui  R2  6800h
sw   R2  R1  6
lui  R2  7000h
sw   R2  R1  11
lui  R2  5800h
sw   R2  R1  9
lui  R2  3800h
sw   R2  R1  14
add  R1  R1  R3  // go to next block type
lli  R2  00F0h   // block type 5
lui  R2  7800h
sw   R2  R1  10
sw   R2  R1  11
sw   R2  R1  14
sw   R2  R1  15  // done with all block types

pop  R31
nop
nop
nop
jr   R31


// TDRBRD draws all blocks on the tetris board
:TDRBRD
push R31
lli  R20 5000h
lui  R20 0001h   // setup board addressing
xor  R21 R21 R21 // set x-pos == 0
xor  R22 R22 R22 // set y-pos == 0
xor  R23 R23 R23
xor  R8  R8  R8
xor  R9  R9  R9
xor  R7 R7 R7
xor  R25 R25 R25
xor  R19 R19 R19
lli  R8  0008h   // set R8 == 8
lli  R9  0009h   // set R9 == 9
lli  R19 0014h   // set R19 == 20
lli  R23 00FFh   // set 23 == lower 8 bit mask
lli  R7  000Ah   // set R7 == 10
lli  R25  000Ch   // set R25 == 12

:TDRBRD2
lw   R5  R20  0  // get current block-word from board

brlt R5  R0  TDRBRD0   // if <0, it must be drawn
br   TDRBRD1

:TDRBRD0
// draw block
mul  R10 R21 R8
inc  R10         // setup UL X-pixel number
add  R12 R10 R8
dec  R12         // setup BR X-pixel number
mul  R11 R22 R25
inc  R11         // setup UL Y-pixel number
add  R13 R11 R25
dec  R13         // setup BR Y-pixel number

and  R5  R23 R5  // isolate color alone
lli  R14 0000h   // preset border color black
breq R5  R0  TDRBRD3
lli  R14 0010h   // is a block: set border color dgreen
:TDRBRD3
add  R15 R5  R0  // transfer color to R15 for XSQRF call
jal  XSQRF

sw   R5  R20  0  // keep board up-to-date

:TDRBRD1
// go to next block
inc  R21
brlt R21 R7 TDRBRD4 // if not x-overflow, branch
xor  R21 R21 R21
inc  R22
brlt R22 R19 TDRBRD4 // if not y-overflow, branch
br   TDRBRDR         // must be done, return

:TDRBRD4
//mul  R6  R22 R7
//add  R6  R6  R21
//add  R20 R6  R20  // R6 = next block-word addr
inc  R20
br   TDRBRD2

:TDRBRDR
// return location
pop  R31
nop
nop
nop
jr   R31

// TDRBRDI draws the initial tetris playing board
// Sized to a 256 x 256 resolution
// DOES NOT SAVE CONTEXTS
:TDRBRDI
push R31
xor  R10 R10 R10  // UL x-pos = 0
xor  R11 R11 R11  // UL y-pos = 0
xor  R12 R12 R12
xor  R13 R13 R13
xor  R14 R14 R14
xor  R15 R15 R15
lli  R12 00FFh
lli  R13 00FFh    // initial draw all-black
jal  XSQRF
lli  R12 0051h    // 81 pixels wide
lli  R13 00F1h    // 241 pixels tall
lli  R14 00FFh    // border color will be white
jal  XSQR         // draw the square
pop  R31
nop
nop
nop
jr   R31

// LLNVT prints a vertical line
// Arguments - R10 - X-position
//             R11 - length of line
//             R12 - Y-position of topmost point
//             R13 - line colour
:XLNVT
push R31
push R1
push R2
push R3
push R11
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R12
:XLNVT0
jal  XVGA
inc  R3
brgt R3  R11 XLNVT1
br  XLNVT0
:XLNVT1
pop  R11
pop  R3
pop  R2
pop  R1
pop  R31
nop
nop
nop
jr   R31

// XLNHZ prints a horizontal line
// Arguments - R10 - X-position of leftmost point
//             R11 - length of line
//             R12 - Y-position of line
//             R13 - line colour
:XLNHZ
push R31
push R1
push R2
push R3
push R11
add  R1  R13  R0
add  R2  R10  R0
add  R3  R12  R0
add  R11 R11  R10
:XLNHZ0
jal XVGA
inc  R2
brgt R2  R11 XLNHZ1
br  XLNHZ0
:XLNHZ1
pop  R11
pop  R3
pop  R2
pop  R1
pop  R31
nop
nop
nop
jr   R31

// XSQRF prints a filled sqaure on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
//             R15 - fill colour
:XSQRF
push R31
push R10
push R11
push R12
push R13
push R14
jal XSQR    // print outline
add  R14  R15  R0  // switch outline colour to fill
:XSQRF0
inc  R10
inc  R11
dec  R12
dec  R13    // close box in 1 pixel
brgt R10 R12 XSQRF1
brgt R11 R13 XSQRF1
jal XSQR
br XSQRF0
:XSQRF1
pop  R14
pop  R13
pop  R12
pop  R11
pop  R10
pop  R31
nop
nop
nop
jr   R31

// XSQR prints a square on the screen
// Arguments - R10 - X-position upper-left
//             R11 - Y-position upper-left
//             R12 - X-position bottom-right
//             R13 - Y-position bottom-right
//             R14 - outline colour
:XSQR
push R31
push R1
push R2
push R3
add  R1  R14  R0
add  R2  R10  R0
add  R3  R11  R0
breq R10 R12  XSQRX
breq R11 R13  XSQRY
:XSQRA
jal XVGA
inc R2
brgt R2 R12 XSQR1
br XSQRA
:XSQR1
dec R2
:XSQRB
inc R3
brgt R3 R13 XSQR2
jal XVGA
br XSQRB
:XSQR2
dec R3
:XSQRC
dec R2
brlt R2 R10 XSQR3
jal XVGA
br XSQRC
:XSQR3
inc R2
:XSQRD
dec R3
breq R3 R11 XSQR4
jal XVGA
br XSQRD
:XSQRX
push R11
push R12
push R13
add R12 R11 R0
sub R11 R13 R11
add R13 R14 R0
jal XLNVT
pop  R13
pop  R12
pop  R11
br XSQR4
:XSQRY
push R11
push R12
push R13
sub R11 R12 R10
add R12 R13 R0
add R13 R14 R0
jal  XLNHZ
pop  R13
pop  R12
pop  R11
:XSQR4
pop  R3
pop  R2
pop  R1
pop  R31
nop
nop
nop
jr   R31

// XVGA prints a pixel to the screen
// Arguments - R1 - color
//             R2 - X-position
//             R3 - Y-position
:XVGA
push R31
push R1
push R2
push R3
push R4
push R5
xor  R4 R4 R4
xor  R5 R5 R5
lli  R4 00FFh
lli  R5 01FFh
and  R1  R1  R4
and  R2  R2  R5
and  R3  R3  R5
lli  R4 8h
lli  R5 12h
sl   R2  R2  R4
sl   R3  R3  R5
or   R1  R1  R2
or   R1  R1  R3
jal  XPUTPX
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
nop
nop
nop
jr   R31

// XNWLN prints a newline character
:XNWLN
push R31
push R1
xor  R1  R1  R1
lli  R1  000Ah        // CR char
jal  XPUTC
lli  R1  000Dh       // LF char
jal  XPUTC
pop  R1
pop  R31
nop
nop
nop
jr   R31

// XGETC gets a character from the user
// and returns it in R1
:XGETC
brchar XGETC2
br XGETC
:XGETC2
add  R1  R29  R0
jr  R31


// XPUTC prints a character in R1
:XPUTC
brvid XPUTC2
br XPUTC
:XPUTC2
add R29 R1 R0
jr  R31

// XPUTPX prints a pixel using SVGA
// pixel data is taken from R1
:XPUTPX
brpix XPUTPX2
br XPUTPX
:XPUTPX2
svga R1
jr   R31

// XRFDMP dumps the register file to the screen
// Notes: Register 29 is not dumped.
// Memory locations 8000h - 8009h are corrupted
// by this procedure.
:XRFDMP
push R31
push R1
push R2
push R3
push R4
push R5
push R6
push R7
push R8
push R15
push R16     // context save

push R31
push R30
push R28
push R27
push R26
push R25
push R24
push R23
push R22
push R21
push R20
push R19
push R18
push R17
push R16
push R15
push R14
push R13
push R12
push R11
push R10
push R9
push R8
push R7
push R6
push R5
push R4
push R3
push R2
push R1
push R0

xor  R2  R2  R2
xor  R4  R4  R4
xor  R5  R5  R5
xor  R6  R6  R6
xor  R7  R7  R7
xor  R8  R8  R8
xor  R15 R15 R15
lli  R2  0052h   // 'R'
lli  R6  0020h   // ' '
lli  R4  003Dh   // '='
lli  R7  001Dh   // 29
lli  R8  001Fh   // 31
lli  R15 8000h

// start printing loop
:XRFDMPA
add  R1  R2  R0
jal  XPUTC       // put 'R'

add  R16 R5  R0
jal  XRG2C       // convert reg num to printable
add  R3  R15 R0
jal  XPRINT       // print register number
add  R1  R6  R0
jal  XPUTC       // print space
add  R1  R4  R0
jal  XPUTC       // print '='
add  R1  R6  R0
jal  XPUTC       // print space

pop  R16         // pop next reg to print
jal  XRG2C       // convert to printable
add  R3  R15 R0
jal  XPRINT       // print register contents
jal  XNWLN       // print new line
inc  R5          // increment current register

breq R5 R7 XRFDMP0
br   XRFDMP1
:XRFDMP0
inc  R5
:XRFDMP1
brgt R5 R8 XRFDMP2
br   XRFDMPA     // start over

:XRFDMP2

pop  R16         // context restore
pop  R15
pop  R8
pop  R7
pop  R6
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
pop  R31
nop
nop
nop
jr   R31



// XRG2C converts a register to
// a printable form (in hex)
// Arguments:
// R15 - Starting address for output
// R16 - Value that will be printed
:XRG2C
push R1
push R2
push R3
push R4
push R5
push R10
push R11
push R13
push R15
xor  R1   R1   R1
xor  R2   R2   R2
xor  R4   R4   R4
xor  R3   R3   R3
xor  R5   R5   R5
lli  R13  FFFCh
lui  R13  FFFFh
lli  R4   0004h
lli  R10  001Ch
lli  R3   0009h
lli  R1   000Fh
sw   R0   R15  9    // null terminate

:XRG2C1
srl  R11   R16  R10 // bring next nibble to LSN
and  R11   R11  R1  // isolate nibble
sub  R10   R10  R4  // subtract 4 from shift amount

// R11 is now between 0000_0000 and 0000_000F
brgt R11   R3   XRG2CA  // if char is A or greater

// char must be between 0 and 9
lli  R2   0030h
add  R11  R11   R2   // now converted to character
br   XRG2C0

:XRG2CA
lli  R2   0037h
add  R11  R11   R2   // now converted to character

:XRG2C0
sw   R11  R15   0    // store off the character
inc  R15             // go to next addr
brgt R10  R13   XRG2C1

// must be done
pop  R15
pop  R13
pop  R11
pop  R10
pop  R5
pop  R4
pop  R3
pop  R2
pop  R1
nop
nop
nop
jr   R31 // return

// XPRINT reads a line from memory and
// prints it on the screen.  Starts
// looking at address specified by R3.
// Expects a null-terminated string.

:XPRINT
push R1
push R3
push R4
add  R4  R31 R0  // save return addr
:XPRINT1
lw   R1  R3  0
breq R1  R0  XPRINT2
jal  XPUTC
inc  R3
br   XPRINT1
:XPRINT2
add  R31 R4  R0
pop  R4
pop  R3
pop  R1
jr   R31

:XQUIT
br XQUIT
stop

